using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using CollectorCompLib;

namespace CollectorWebSite
{
	/// <summary>
	/// Summary description for CollectorTrading.
	/// </summary>
	public class CollectorTrading : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.TextBox sellerIDTextBox;
		protected System.Web.UI.WebControls.TextBox buyerIDTextBox;
		protected System.Web.UI.WebControls.Label sellerItemsCountLabel;
		protected System.Web.UI.WebControls.Label buyerItemsCountLabel;
		protected System.Web.UI.WebControls.TextBox sellCountTextBox;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label messageLabel;
		protected System.Web.UI.WebControls.Button refreshButton;
		protected System.Web.UI.WebControls.Button tradeButton;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.refreshButton.Click += new System.EventHandler(this.refreshButton_Click);
			this.sellCountTextBox.TextChanged += new System.EventHandler(this.sellCountTextBox_TextChanged);
			this.buyerIDTextBox.TextChanged += new System.EventHandler(this.buyerIDTextBox_TextChanged);
			this.sellerIDTextBox.TextChanged += new System.EventHandler(this.sellerIDTextBox_TextChanged);
			this.tradeButton.Click += new System.EventHandler(this.tradeButton_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void sellerIDTextBox_TextChanged(object sender, System.EventArgs e)
		{
			Collector seller = new CollectorFactory().getCollector(Convert.ToInt32(sellerIDTextBox.Text));
			if (seller != null)
			{
				sellerItemsCountLabel.Text = seller.collectionCount.ToString();
			}
			else
			{
				sellerItemsCountLabel.Text = "Invalid: " + sellerIDTextBox.Text;
				sellerIDTextBox.Text = "";
			}

			enableDisableButtons();
		}

		private void sellCountTextBox_TextChanged(object sender, System.EventArgs e)
		{
			enableDisableButtons();
		}

		private void buyerIDTextBox_TextChanged(object sender, System.EventArgs e)
		{
			Collector buyer = new CollectorFactory().getCollector(Convert.ToInt32(buyerIDTextBox.Text));
			if (buyer != null)
			{
				buyerItemsCountLabel.Text = buyer.collectionCount.ToString();
			}
			else
			{
				buyerItemsCountLabel.Text = "Invalid: " + buyerIDTextBox.Text;
				buyerIDTextBox.Text = "";
			}

			enableDisableButtons();
		}

		private void enableDisableButtons()
		{
			tradeButton.Enabled = false;
			refreshButton.Enabled = false;
			if (sellerIDTextBox.Text.Trim() != ""  && buyerIDTextBox.Text.Trim() != "")
			{
				refreshButton.Enabled = true;

				if (sellCountTextBox.Text.Trim() != "")
					tradeButton.Enabled = true;
			}
		}

		private void tradeButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				Collector seller = new CollectorFactory().getCollector(Convert.ToInt32(sellerIDTextBox.Text));

				Collector buyer = new CollectorFactory().getCollector(Convert.ToInt32(buyerIDTextBox.Text));

				int count = Convert.ToInt32(sellCountTextBox.Text);

				seller.sell(count);
				buyer.buy(count);
			}
			catch(Exception ex)
			{
				messageLabel.Text = ex.Message;
			}
		}

		private void refreshButton_Click(object sender, System.EventArgs e)
		{
			try
			{
				Collector seller = new CollectorFactory().getCollector(Convert.ToInt32(sellerIDTextBox.Text));

				Collector buyer = new CollectorFactory().getCollector(Convert.ToInt32(buyerIDTextBox.Text));

				sellerItemsCountLabel.Text = seller.collectionCount.ToString();
				buyerItemsCountLabel.Text = buyer.collectionCount.ToString();
			}
			catch(Exception ex)
			{
				messageLabel.Text = ex.Message;
			}		
		}
	}
}
